/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id:$
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.classloader.view {

import flash.geom.Point;

import mx.core.ClassFactory;

import org.ow2.jonas.admin.classloader.model.ClassLoaderModelLocator;
import org.un.cava.birdeye.ravis.components.renderers.edgeLabels.BaseEdgeLabelRenderer;
import org.un.cava.birdeye.ravis.graphLayout.data.Graph;
import org.un.cava.birdeye.ravis.graphLayout.layout.HierarchicalLayouter;
import org.un.cava.birdeye.ravis.graphLayout.visual.VisualGraph;
import org.un.cava.birdeye.ravis.graphLayout.visual.edgeRenderers.FlowEdgeRenderer;

public class NodeVisualGraph extends VisualGraph {

    private var model : ClassLoaderModelLocator = ClassLoaderModelLocator.getInstance();

    /*[Bindable]
    [Embed(source="/../assets/ui/bean.png")]
    public var easyBeansIcon : Class;

    [Bindable]
    [Embed(source="/../assets/ui/bean.png")]
    public var localBeanIcon : Class;

    [Bindable]
    [Embed(source="/../assets/ui/bean-remote.png")]
    public var remoteBeanIcon : Class;


    [Bindable]
    [Embed(source="/../assets/ui/tomcat.png")]
    public var tomcatIcon : Class;*/


    public function NodeVisualGraph() {
    }


    public function fillNewData(xml : XML) : void {
        this.graph = new Graph("XMLAsDocsGraph", false, xml);


        // Select the first available node as starting root node
       if (xml.elements("Node").length() > 0) {
            this.currentRootVNode = this.graph.nodeByStringId(xml.elements("Node")[0].@id).vnode;
			model.vgraph.centerNodeByStringId(xml.elements("Node")[0].@id);
			this._scale = 1;
			this._origin = new Point(0,0);
			this.width
        } else {
            model.showingGraph = false;
            return;
        }

		//this.currentRootVNode = this.graph.nodeByStringId("root").vnode;

        // layout (hierarchical)
        var layouter : HierarchicalLayouter = new HierarchicalLayouter(this);
        layouter.orientation = HierarchicalLayouter.ORIENT_TOP_DOWN;
        this.layouter = layouter;

		layouter.breadth = 75;

		layouter.enableSiblingSpread = true;
		layouter.interleaveSiblings = true;

		this.layouter.layoutChanged = true;


        // Node renderer
        this.itemRenderer = new ClassFactory(ClassLoaderGraphIconRenderer);

        // Change the set of icons
      /*  EmbeddedIcons.n02Icon = tomcatIcon;
        EmbeddedIcons.n10Icon = easyBeansIcon;
        EmbeddedIcons.n11Icon = localBeanIcon;
        EmbeddedIcons.n12Icon = remoteBeanIcon;
*/

        // Edge renderer
        this.edgeRenderer = new FlowEdgeRenderer(this.edgeDrawGraphics);
        // Edge label renderer
        this.edgeLabelRenderer = new ClassFactory(BaseEdgeLabelRenderer);

		//
		model.vgraph.maxVisibleDistance = 10;


        // Settings
        this.layouter.autoFitEnabled = false;
        this.layouter.disableAnimation = false;
		this.layouter.linkLength = 10;
		this.layouter.layoutChanged = true;

        // distance
        this.maxVisibleDistance = 10;

        // refresh the graph
        this.refresh();
        this.draw();

    }
}
}